#!/bin/env python
# -*- coding: utf-8 -*-

# ------------------------------------------------------------
# opensecurityd
#   
# the opensecurityd as RESTful server
#
# Autor: Mihai Bartha, <mihai.bartha@ait.ac.at>       
#
# Copyright (C) 2013 AIT Austrian Institute of Technology
# AIT Austrian Institute of Technology GmbH
# Donau-City-Strasse 1 | 1220 Vienna | Austria
# http://www.ait.ac.at
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation version 2.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, 
# Boston, MA  02110-1301, USA.
# ------------------------------------------------------------


# ------------------------------------------------------------
# imports

import unittest

import os
import os.path
import sys
import cygwin
import vmmanager
gvm_mgr = None

class TestVMManager(unittest.TestCase):
    
    def setUp(self):
        pass
    
    @classmethod
    def setUpClass(self):
        global gvm_mgr
        gvm_mgr = vmmanager.VMManager.getInstance()
        pass
    
    @unittest.skip("skipping")
    def testGetTemplateUUID(self):
        template = vmmanager.VMManager.getTemplateUUID()
        self.assertIsNotNone(template,  "returned no UUID for template")
    
    #@unittest.skip("skipping (requires running vmmanager)")    
    def testUpdateTemplate(self):
        gvm_mgr.updateTemplate()
        pass
    
    #@classmethod
    #def tearOffClass(self):
    #    gvm_mgr.stop()
    #    gvm_mgr.cleanup()
        

if __name__ == '__main__':
    TestVMManager.setUpClass()
    
    suite = unittest.TestLoader().loadTestsFromTestCase(TestVMManager)
    unittest.TextTestRunner().run(suite)
    
#    logger = setupLogger('Cygwin')
#    c = Cygwin()
#    unittest.main()
    #man = VMManager.getInstance()
    #man.listVM()
    #print man.getConnectedRSDs()
    #print man.getNetworkDrives()
    #man.genNetworkDrive()
    #drive_bitmask = ctypes.cdll.kernel32.GetLogicalDrives()
    #print list(itertools.compress(string.ascii_uppercase,  map(lambda x:ord(x) - ord('0'), bin(drive_bitmask)[:1:-1])))
    #print list(map(chr, range(68, 91))) 
    #print Cygwin.getRegEntry('SYSTEM\CurrentControlSet\Enum\USB', 'VID_1058&PID_0704')[0]
    #devices = VMManager.getConnectedRSDS()
    #print devices
    
    #drives = VMManager.getLogicalDrives()
    #print drives
    #print VMManager.getDriveType("E")
    #print VMManager.getVolumeInfo("E")
    #print VMManager.getNetworkPath("E")
    
    #vmm.backupFile()
    #for device in devices.values():
    #    #print device
    #    if VMManager.isMassStorageDevice(device):
    #        print device
        
    
    
    #time.sleep(-1)
    #man.listVM()
    #man.listVM()
    #man.listVM()
    #man.listVM()
    #man.genCertificateISO('SecurityDVM0')
    #man.guestExecute('SecurityDVM0', '/bin/ls -la')
    #logger = setupLogger('VMManager')
    #c = Cygwin()
    
    #man.sshExecute('/bin/ls -la', 'SecurityDVM0')
    #man.sshExecuteX11('/usr/bin/iceweasel', 'SecurityDVM0')
    #man.removeVM('SecurityDVM0')
    #man.netUse('192.168.56.134', 'USB\\')
    #ip = '192.168.56.139'
    
    #man.cygwin_path = 'c:\\cygwin64\\bin\\'
    #man.handleDeviceChange()
    #print man.listSDVM()
    #man.configureHostNetworking()
    #new_vm = man.generateSDVMName()
    #man.createVM(new_vm)
    
    #print Cygwin.cmd()
    #man.isAvailable('c:')
    #ip = man.getHostOnlyIP('SecurityDVM0')
    #man.mapNetworkDrive('h:', '\\\\' + ip + '\Download', None, None)
    
    #man.genCertificateISO(new_vm)
    #man.attachCertificateISO(new_vm)
    
    #man.attachCertificateISO(vm_name)
    #man.guestExecute(vm_name, "ls")
    #man.sshGuestX11Execute('SecurityDVM1', '/usr/bin/iceweasel')
    #time.sleep(60)
    #print man.cygwinPath("C:\Users\BarthaM\VirtualBox VMs\SecurityDVM\.ssh\*")
    #man.genCertificateISO('SecurityDVM')
    #man.attachCertificateISO('SecurityDVM')
    #man.isStorageAttached('SecurityDVM')
    #man.guestExecute('SecurityDVM', 'sudo apt-get -y update')
    #man.guestExecute('SecurityDVM', 'sudo apt-get -y upgrade' )
    
    #man.stopVM('SecurityDVM')
    #man.storageDetach('SecurityDVM')
    #man.changeStorageType('C:\Users\BarthaM\VirtualBox VMs\SecurityDVM\SecurityDVM.vmdk','immutable')
    #man.storageAttach('SecurityDVM')
    
    
    #cmd = "c:\\cygwin64\\bin\\bash.exe --login -c \"/bin/ls\""
    #man.execute(cmd)